// Written by TeTeT

[] spawn {
	sleep 0.3;
	private _channelID = radioChannelCreate [[0.9, 0.9, 0.9, 0.8], "Old Salt", "%CHANNEL_LABEL", [player, airboss]];

	if (_channelID == 0) then {
		"Custom Radio Channel Creation failed" call bis_fnc_error;
	};

	Nimitz setVariable ["ttt_nimitz_radio", _channelID];
};

[Nimitz] spawn {
	params ["_carrier"];

	sleep 0.5;
	private _parkingEnd = [_carrier, "C2T"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_parkingEnd = _parkingEnd getPos [1, getDir _carrier - 90];
	_parkingEnd set [2, (getPosASL _carrier select 2) + 17.441];
	private _parkingStart = [_carrier, "C2"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_parkingStart = _parkingStart getPos [2, getDir _carrier - 90];
	_parkingStart set [2, (getPosASL _carrier select 2) + 17.441];

	private _parkingPos = _parkingEnd;
	private _parkingPositions = [];
	private _planes = [];
	while {_parkingPos distance _parkingStart > 25} do {
		_parkingPositions pushBack _parkingPos;
		[_parkingPos] call ttt_amp_kf_fnc_spawnParkedPlane;

		_parkingPos = _parkingPos getPos [-13, getDir _carrier];
		_parkingPos set [2, (getPosASL _carrier select 2) + 17.441];
	};

	// need to initialize point as well later
	private _allParkingPositions = createHashMapFromArray [
		["crotch", _parkingPositions],
		["point", []]
	];
	_carrier setVariable ["ttt_nimitz_parkingPositions", _allParkingPositions];	
};

ttt_amp_kf_fnc_startEventsInit = {
	params ["_nimitz"];

	[_nimitz, "ttt_nimitz_planeRequestStart", ttt_amp_kf_fnc_requestStart] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeTaxiToWeaponsEle", ttt_amp_kf_fnc_raiseWeaponsElevator] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeRequestToCat3", ttt_amp_kf_fnc_requestToCat3] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeRequestToCat3", ttt_amp_kf_fnc_lowerWeaponsElevator] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeRequestToCat3", ttt_amp_kf_fnc_launchParkedPlane] call BIS_fnc_addScriptedEventHandler;
	// [_nimitz, "ttt_nimitz_planeLaunched", ttt_amp_kf_fnc_launchNextParkedPlane] call BIS_fnc_addScriptedEventHandler;
};

ttt_amp_kf_fnc_spawnParkedPlane = {
	params ["_parkingPos"];
	private _plane = createVehicle ["JS_JC_FA18E", _parkingPos, [], 0, "NONE"];
	_plane animate ["l_wingfold", 1, true];
	_plane animate ["r_wingfold", 1, true];
	[_plane, 0] call ttt_amp_kf_fnc_clearPlane;
	_plane setPosASL _parkingPos;
	_plane setDir (getDir _carrier + 120);
};

/**
 * Author:
 * - Grumpy Old Man, adjusted by TeTeT
 **/
ttt_amp_kf_fnc_clearPlane = {
	params ["_plane", ["_delay", 1]];
	{
		[_plane, [_foreachIndex + 1, "", true]] remoteexec ["setPylonLoadOut", 0];
		[_plane, [_foreachIndex + 1, 0]] remoteexec ["setAmmoOnPylon", 0];
		sleep _delay;
	} forEach (GetPylonMagazines _plane);
	private _pylonWeapons = [];
	{ _pylonWeapons append getArray (_x >> "weapons") } forEach ([_plane, configNull] call BIS_fnc_getTurrets);
	{ [_plane, _x] remoteexec ["removeWeaponGlobal", 0] } forEach ((weapons _plane) - _pylonWeapons);	
	sleep _delay;
};

// hard coding the first start sequence
[Nimitz] spawn {
	params ["_carrier"];
	[_carrier] call ttt_amp_kf_fnc_startEventsInit;
	sleep 1;
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	// while {not isNull ([_carrier] call ttt_amp_kf_fnc_launchParkedPlane)} do {
	// 	sleep 10;
	// };
	// airboss customChat [_radio, "All parked planes launched"];
	[_carrier] call ttt_amp_kf_fnc_launchParkedPlane;
};

ttt_amp_kf_fnc_requestStart = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	if ([_carrier, _plane, "C1"] call ttt_amp_kf_fnc_checkPlaneToMempoint == "C") then {
		airboss customChat [_radio, "Taxi to cat 1"];
		_plane setVariable ["ttt_nimitz_taxiAttemptToCat1", nil];
		createVehicleCrew _plane;
		// Cannot fight the AI
		(driver _plane) setDamage 1;
		_plane engineOn true;
		private _C1 = [_carrier, "C1"] call ttt_amp_kf_fnc_getMemPointNimitz;
		[_carrier, _plane, _plane, _C1, (vectorDir _carrier) vectorMultiply -1, "_this call ttt_amp_kf_fnc_atCat1"] call ttt_amp_kf_fnc_taxiPlane;
	} else {
		airboss customChat [_radio, "Taxi to cat 1 blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_plane getVariable ["ttt_nimitz_taxiAttemptToCat1", 0]) + 1;
		
		if (_attempts == 12) then {
			airboss customChat [_radio, "Giving up taxiing, despawning plane on the spot"];
			deleteVehicleCrew _plane;
			deleteVehicle _plane;
		} else {
			_plane setVariable ["ttt_nimitz_taxiAttemptToCat1", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_requestStart;
			};
		};
	};
	_carrier;
};

ttt_amp_kf_fnc_launchNextParkedPlane = {
	params ["_catName", "_plane", "_nimspots"];
	private _carrier = _nimspots getVariable "TTT_NimitzParent";

	[_carrier] call ttt_amp_kf_fnc_launchParkedPlane;
};

ttt_amp_kf_fnc_launchParkedPlane = {
	params ["_carrier"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	airboss customChat [_radio, "Initiating launch cycle"];

	private _parkingPos = [];
	private _parkingArea = "";
	private _plane = objNull;
	private _C2 = [_carrier, "C2"] call ttt_amp_kf_fnc_getMemPointNimitz;
	{
		airboss customChat [_radio, format ["Checking %1", _x]];
		private _possibleParkingPos = [
			_y, 
			[_C2], 
			{_input0 distance _x}, 
			"ASCEND", 
			{not ([_carrier, _x] call ttt_amp_kf_fnc_parkingFree)}
		] call BIS_fnc_sortBy;
		if (count _possibleParkingPos > 0) then {
			_parkingPos = _possibleParkingPos select 0;
			_parkingArea = _x;
			_plane = _parkingPos nearEntities [["Air"], 5] select 0;
		} else {
			airboss customChat [_radio, "No parked plane"];
		};
	} forEach (_carrier getVariable "ttt_nimitz_parkingPositions");

	if (not isNull _plane) then {
		systemChat format ["Found a plane: %1", _plane];
		[_carrier, "ttt_nimitz_planeRequestStart", [_carrier, _plane], false] 
			call BIS_fnc_callScriptedEventHandler;
	};
	_plane;
};

ttt_amp_kf_fnc_atCat1 = {
	params ["_timeline"];

	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	_plane animateSource ["wheel_rot_source", 0, true];

	private _weaponsElevator = [_carrier, "E5Top"] call ttt_amp_kf_fnc_getMemPointNimitz;
	private _weapEleUnload = _weaponsElevator getPos [8, getDir _carrier + 90];
	_weapEleUnload set [2, (getPosASL _carrier select 2) + 17.441];

	if ([_carrier, _plane, _weapEleUnload] call ttt_amp_kf_fnc_checkPlaneToPoint == "C") then {
		airboss customChat [_radio, "Taxi to weapons elevator"];
		_plane setVariable ["ttt_nimitz_taxiAttemptToWeapEle", nil];
		[_carrier, "ttt_nimitz_planeTaxiToWeaponsEle", [_carrier, _plane], false] 
			call BIS_fnc_callScriptedEventHandler;
		[_carrier, _plane, _plane, _weapEleUnload, (vectorDir _carrier) vectorMultiply -1, "_this call ttt_amp_kf_fnc_planeAtWeapons"] call ttt_amp_kf_fnc_taxiPlane;
	} else {
		airboss customChat [_radio, "Taxi to weapons elevator blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_plane getVariable ["ttt_nimitz_taxiAttemptToWeapEle", 0]) + 1;
		if (_attempts == 12) then {
			airboss customChat [_radio, "Giving up taxiing, despawning plane on the spot"];
			deleteVehicleCrew _plane;
			deleteVehicle _plane;
		} else {
			_plane setVariable ["ttt_nimitz_taxiAttemptToWeapEle", _attempts];
			[_timeline] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_atCat1;
			};
		};
	};
	_carrier;
};

ttt_amp_kf_fnc_planeAtWeapons = {
	_this spawn {
		params ["_timeline"];

		private _carrier = _timeline getVariable "ttt_amp_carrier";
		private _plane = _timeline getVariable "ttt_amp_plane";
		private _radio = _carrier getVariable "ttt_nimitz_radio";

		_plane animateSource ["wheel_rot_source", 0, true];
		_plane engineOn false;
		if (missionnamespace getVariable ["ttt_amp_kf_flightOpsLoadout", ""] != "") then {
			systemChat "Applying flight ops skin and loadout";
			// We make the plane the ammo source so it can change the loadout
			_plane setVariable ["TTT_fnc_ammoCargo", 10000, true];
			[_plane, ttt_amp_kf_flightOpsLoadout] call ttt_amp_kf_fnc_loadFlightOpsPreset;
			waitUntil { sleep 0.1; not (_plane getVariable ["TTT_fnc_aircraftLoadoutRearmingInProgress", false]) };
			_plane setVariable ["TTT_fnc_ammoCargo", nil];

		} else {
			airboss customChat [_radio, "No plane customization selected"];
			sleep 5;
		};
		[_carrier, "ttt_nimitz_planeRequestToCat3", [_carrier, _plane], false] 
			call BIS_fnc_callScriptedEventHandler;
	};
};

ttt_amp_kf_fnc_requestToCat3 = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	if ([_carrier, _plane, "C3"] call ttt_amp_kf_fnc_checkPlaneToMempoint == "C") then {
		airboss customChat [_radio, "Taxi to cat 3"];
		_plane setVariable ["ttt_nimitz_taxiAttemptToCat3", nil];
		_plane setFuel 1;
		_plane engineOn true;
		deleteVehicleCrew _plane;
		createVehicleCrew _plane;
		[_carrier, _plane, "C3", false] call ttt_amp_kf_fnc_eleToTakeOff;
	} else {
		airboss customChat [_radio, "Taxi to cat 3 blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_plane getVariable ["ttt_nimitz_taxiAttemptToCat3", 0]) + 1;
		
		if (_attempts == 12) then {
			airboss customChat [_radio, "Giving up taxiing, despawning plane on the spot"];
			deleteVehicleCrew _plane;
			deleteVehicle _plane;
		} else {
			_plane setVariable ["ttt_nimitz_taxiAttemptToCat3", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_requestToCat3;
			};
		};
	};
	_carrier;

};


ttt_amp_kf_fnc_raiseWeaponsElevator = {
	params ["_carrier", "_plane"];
	[_carrier getVariable "JDG_carrier_hangar_1", 2] spawn ttt_fnc_elevator;
	_carrier;
};

ttt_amp_kf_fnc_lowerWeaponsElevator = {
	params ["_carrier", "_plane"];
	[_carrier getVariable "JDG_carrier_hangar_1", 3] spawn ttt_fnc_elevator;
	_carrier;
};

ttt_amp_kf_fnc_getGroup = {
	params ["_carrier"];
	private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
	if (isNull _group) then {
		_group = createGroup [sideLogic, true];
		_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
	};
	_group;
};

ttt_amp_kf_fnc_parkingFree = {
	params ["_carrier", "_pos", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];
	private _planeSize = 6; // wingspan roughly, wings folded

	private _poly = [
		_pos getPos [_planeSize, getDir _carrier + 120],
		_pos getPos [_planeSize, getDir _carrier + 210],
		_pos getPos [_planeSize, getDir _carrier + 300],
		_pos getPos [_planeSize, getDir _carrier + 30]
	];

	private _ret = true;

	{
		if ( (getPosASL _x) # 2 - (getPosASL _carrier) # 2 < 20 and 
			getPosASL _x inPolygon _poly and 
			not (toLower typeOf _x in _excludeList) ) then {
				// systemChat format ["%3 - In the way: %1", _x, typeOf _x];
				_ret = false;
		};
	// probably want to cache that nearEntities call
	} forEach (_pos nearEntities [["Air", "Land", "Ship"], 5]);
	_ret;
};

ttt_amp_kf_fnc_taxiPlane = {
	params ["_carrier", "_plane", "_vehicle", "_pos", "_dir", "_callback", ["_speed", 3.6]];

	private _time = (_vehicle distance _pos) / _speed; // 10 km/h by default, 3.6 m/s
	private _keysData = [
		// Tried to turn the plane around, didn't look nice
		[	
			0,
			getPosASL _vehicle,
			[
				vectorDir _vehicle,
				[0,0,1]
			],
			[
				["Time", 0],
				["LeaveTangent", vectorDir _vehicle],
				["LeaveTangentWeight", 100],
				["InterpMode", 1]
			]
		],
		[
			1,
			_pos,
			[
				_dir,
				[0,0,1]
			],
			[
				["Time", _time],
				["ArriveTangent", _dir vectorMultiply -1],
				["ArriveTangentWeight", 100],
				["InterpMode", 1]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", _time],
	    ["Loop", false],
		["InterpMode", 1],
		["EventFinished", _callback]
	];

	private _curvesData = [
	    [ // curve1
	    	[_vehicle], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 3],
	            ["TimeInSeconds", true]
	        ],
	        _keysData
	    ]
	];

	private _group = [_carrier] call ttt_amp_kf_fnc_getGroup;

	private _timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
	_timeline setVariable ["ttt_amp_carrier", _carrier];
	_timeline setVariable ["ttt_amp_plane", _plane];
	[_timeline] call BIS_fnc_timeline_play;
	_vehicle animateSource ["wheel_rot_source", 1e12];
	_timeline
};

ttt_amp_kf_fnc_checkPlaneToMempoint = {
	params ["_carrier", "_plane", "_memPointName", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];

	private _memPoint = [_carrier, _memPointName] call ttt_amp_kf_fnc_getMempointNimitz;
	[_carrier, _plane, _memPoint] call ttt_amp_kf_fnc_checkPlaneToPoint;
};

ttt_amp_kf_fnc_checkPlaneToPoint = {
	params ["_carrier", "_plane", "_point", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];

	private _planeSize = 6;

	private _poly = [
		_plane getPos [_planeSize, (_plane getDir _point) + 90],
		_plane getPos [_planeSize, (_plane getDir _point) - 90],
		_point getPos [_planeSize, (_plane getDir _point) - 90],
		_point getPos [_planeSize, (_plane getDir _point) + 90]
	];

	private _ret = "C";
	{
		if ( (getPosASL _x) # 2 - (getPosASL _carrier) # 2 < 20 and 
			getPosASL _x inPolygon _poly and 
			not (toLower typeOf _x in _excludeList) and 
			_x != _plane ) then {
				// systemChat format ["%3 - In the way: %1 (%2)", _x, typeOf _x, _elevator];
				_ret = "F";
		};
	} forEach (_plane nearEntities [["Air", "Land", "Ship"], _plane distance _point]);

	_ret;
};
